[PATCH] D73707: [TSAN] Parameterize the hard-coded threshold of deflake in tsan test
Anh Tuyen Tran via Phabricator via llvm-commits
llvm-commits at lists.llvm.org
Wed Feb 12 07:55:51 PST 2020
This revision was automatically updated to reflect the committed changes.
Closed by commit rGdadc214e4d9d: Title: [TSAN] Parameterize the hard-coded threshold of deflake in tsan test (authored by anhtuyen).
Repository:
rG LLVM Github Monorepo
CHANGES SINCE LAST ACTION
https://reviews.llvm.org/D73707/new/
https://reviews.llvm.org/D73707
Files:
compiler-rt/test/tsan/CMakeLists.txt
compiler-rt/test/tsan/deflake.bash
compiler-rt/test/tsan/lit.cfg.py
compiler-rt/test/tsan/lit.site.cfg.py.in
Index: compiler-rt/test/tsan/lit.site.cfg.py.in
===================================================================
--- compiler-rt/test/tsan/lit.site.cfg.py.in
+++ compiler-rt/test/tsan/lit.site.cfg.py.in
@@ -6,6 +6,7 @@
config.apple_platform = "@TSAN_TEST_APPLE_PLATFORM@"
config.target_cflags = "@TSAN_TEST_TARGET_CFLAGS@"
config.target_arch = "@TSAN_TEST_TARGET_ARCH@"
+config.deflake_threshold = "@TSAN_TEST_DEFLAKE_THRESHOLD@"
# Load common config for all compiler-rt lit tests.
lit_config.load_config(config, "@COMPILER_RT_BINARY_DIR@/test/lit.common.configured")
Index: compiler-rt/test/tsan/lit.cfg.py
===================================================================
--- compiler-rt/test/tsan/lit.cfg.py
+++ compiler-rt/test/tsan/lit.cfg.py
@@ -75,7 +75,7 @@
# Define CHECK-%os to check for OS-dependent output.
config.substitutions.append( ('CHECK-%os', ("CHECK-" + config.host_os)))
-config.substitutions.append( ("%deflake ", os.path.join(os.path.dirname(__file__), "deflake.bash") + " "))
+config.substitutions.append( ("%deflake ", os.path.join(os.path.dirname(__file__), "deflake.bash") + " " + config.deflake_threshold))
# Default test suffixes.
config.suffixes = ['.c', '.cpp', '.m', '.mm']
Index: compiler-rt/test/tsan/deflake.bash
===================================================================
--- compiler-rt/test/tsan/deflake.bash
+++ compiler-rt/test/tsan/deflake.bash
@@ -1,13 +1,22 @@
#!/usr/bin/env bash
# This script is used to deflake inherently flaky tsan tests.
# It is invoked from lit tests as:
-# %deflake mybinary
+# %deflake $THRESHOLD mybinary
# which is then substituted by lit to:
-# $(dirname %s)/deflake.bash mybinary
-# The script runs the target program up to 10 times,
+# $(dirname %s)/deflake.bash $THRESHOLD mybinary
+# - When TSAN_TEST_DEFLAKE_THRESHOLD is defined to a positive integer value,
+# THRESHOLD will be the defined value.
+# - When TSAN_TEST_DEFLAKE_THRESHOLD is not defined, THRESHOLD will be 10.
+# The script runs the target program up to $THRESHOLD times,
# until it fails (i.e. produces a race report).
-for i in $(seq 1 10); do
+THRESHOLD="${1}"
+shift
+
+# Early exit if $THRESHOLD is not a non-negative integer
+[[ "${THRESHOLD}" =~ ^[0-9]+$ ]] || exit 1
+
+while (( THRESHOLD-- )); do
OUT=`$@ 2>&1`
if [[ $? != 0 ]]; then
echo "$OUT"
Index: compiler-rt/test/tsan/CMakeLists.txt
===================================================================
--- compiler-rt/test/tsan/CMakeLists.txt
+++ compiler-rt/test/tsan/CMakeLists.txt
@@ -19,6 +19,10 @@
set(TSAN_TESTSUITES)
+if (NOT DEFINED TSAN_TEST_DEFLAKE_THRESHOLD)
+ set(TSAN_TEST_DEFLAKE_THRESHOLD "10")
+endif()
+
set(TSAN_TEST_ARCH ${TSAN_SUPPORTED_ARCH})
if(APPLE)
darwin_filter_host_archs(TSAN_SUPPORTED_ARCH TSAN_TEST_ARCH)
-------------- next part --------------
A non-text attachment was scrubbed...
Name: D73707.244185.patch
Type: text/x-patch
Size: 2797 bytes
Desc: not available
URL: <http://lists.llvm.org/pipermail/llvm-commits/attachments/20200212/7c494c6b/attachment.bin>
More information about the llvm-commits
mailing list